=== modified file 'jujupy.py'
--- jujupy.py	2015-09-02 15:14:52 +0000
+++ jujupy.py	2015-09-02 16:25:47 +0000
@@ -109,70 +109,6 @@
         super(CannotConnectEnv, self).__init__(e.returncode, e.cmd, e.output)
 
 
-class JujuClientDevel:
-    # This client is meant to work with the latest version of juju.
-    # Subclasses will retain support for older versions of juju, so that the
-    # latest version is easy to read, and older versions can be trivially
-    # deleted.
-
-    def __init__(self, version, full_path):
-        self.version = version
-        self.full_path = full_path
-        self.debug = False
-
-    @classmethod
-    def get_version(cls):
-        return EnvJujuClient.get_version()
-
-    @classmethod
-    def get_full_path(cls):
-        return EnvJujuClient.get_full_path()
-
-    @classmethod
-    def by_version(cls):
-        version = cls.get_version()
-        full_path = cls.get_full_path()
-        if version.startswith('1.16'):
-            raise Exception('Unsupported juju: %s' % version)
-        else:
-            return JujuClientDevel(version, full_path)
-
-    def get_env_client(self, environment):
-        return EnvJujuClient(environment, self.version, self.full_path, None,
-                             self.debug)
-
-    def bootstrap(self, environment):
-        """Bootstrap, using sudo if necessary."""
-        return self.get_env_client(environment).bootstrap()
-
-    def destroy_environment(self, environment):
-        return self.get_env_client(environment).destroy_environment()
-
-    def get_juju_output(self, environment, command, *args, **kwargs):
-        return self.get_env_client(environment).get_juju_output(
-            command, *args, **kwargs)
-
-    def get_status(self, environment, timeout=60, raw=False, *args):
-        """Get the current status as a dict."""
-        return self.get_env_client(environment).get_status(timeout, raw, *args)
-
-    def get_env_option(self, environment, option):
-        """Return the value of the environment's configured option."""
-        return self.get_env_client(environment).get_env_option(option)
-
-    def quickstart(self, environment, bundle):
-        return self.get_env_client(environment).quickstart(bundle)
-
-    def set_env_option(self, environment, option, value):
-        """Set the value of the option in the environment."""
-        return self.get_env_client(environment).set_env_option(option, value)
-
-    def juju(self, environment, command, args, sudo=False, check=True):
-        """Run a command under juju for the current environment."""
-        return self.get_env_client(environment).juju(
-            command, args, sudo, check)
-
-
 class AgentsNotStarted(Exception):
 
     def __init__(self, environment, status):

=== modified file 'test_jujupy.py'
--- test_jujupy.py	2015-09-02 16:21:03 +0000
+++ test_jujupy.py	2015-09-02 16:25:47 +0000
@@ -24,7 +24,6 @@
 from jujuconfig import (
     get_environments_path,
     get_jenv_path,
-    get_juju_home,
     NoSuchEnvironment,
 )
 from jujupy import (
@@ -42,7 +41,6 @@
     jes_home_path,
     JESByDefault,
     JESNotSupported,
-    JujuClientDevel,
     JUJU_DEV_FEATURE_FLAGS,
     make_client,
     make_jes_home,
@@ -1525,249 +1523,6 @@
         self.assertEqual(client.juju_home, tb_home)
 
 
-class TestJujuClientDevel(TestCase):
-
-    def test_get_version(self):
-        value = ' 5.6 \n'
-        with patch('subprocess.check_output', return_value=value) as vsn:
-            version = JujuClientDevel.get_version()
-        self.assertEqual('5.6', version)
-        vsn.assert_called_with(('juju', '--version'))
-
-    def test_by_version(self):
-        def juju_cmd_iterator():
-            yield '1.17'
-            yield '1.16'
-            yield '1.16.1'
-            yield '1.15'
-
-        context = patch.object(
-            JujuClientDevel, 'get_version',
-            side_effect=juju_cmd_iterator().next)
-        with context:
-            self.assertIs(JujuClientDevel,
-                          type(JujuClientDevel.by_version()))
-            with self.assertRaisesRegexp(Exception, 'Unsupported juju: 1.16'):
-                JujuClientDevel.by_version()
-            with self.assertRaisesRegexp(Exception,
-                                         'Unsupported juju: 1.16.1'):
-                JujuClientDevel.by_version()
-            client = JujuClientDevel.by_version()
-            self.assertIs(JujuClientDevel, type(client))
-            self.assertEqual('1.15', client.version)
-
-    def test_bootstrap_hpcloud(self):
-        env = SimpleEnvironment('hp')
-        with patch.object(env, 'hpcloud', lambda: True):
-            with patch.object(EnvJujuClient, 'juju') as mock:
-                JujuClientDevel(None, None).bootstrap(env)
-            mock.assert_called_with(
-                'bootstrap', ('--constraints', 'mem=2G'), False)
-
-    def test_bootstrap_non_sudo(self):
-        env = SimpleEnvironment('foo')
-        with patch.object(SimpleEnvironment, 'needs_sudo', return_value=False):
-            with patch.object(EnvJujuClient, 'juju') as mock:
-                JujuClientDevel(None, None).bootstrap(env)
-            mock.assert_called_with(
-                'bootstrap', ('--constraints', 'mem=2G'), False)
-
-    def test_bootstrap_sudo(self):
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, None)
-        with patch.object(SimpleEnvironment, 'needs_sudo', return_value=True):
-            with patch.object(EnvJujuClient, 'juju') as mock:
-                client.bootstrap(env)
-            mock.assert_called_with(
-                'bootstrap', ('--constraints', 'mem=2G'), True)
-
-    def test_destroy_environment_non_sudo(self):
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, None)
-        with patch.object(SimpleEnvironment, 'needs_sudo', return_value=False):
-            with patch.object(EnvJujuClient, 'juju') as mock:
-                client.destroy_environment(env)
-            mock.assert_called_with(
-                'destroy-environment', ('foo', '--force', '-y'),
-                False, check=False, include_e=False, timeout=600)
-
-    def test_destroy_environment_sudo(self):
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, None)
-        with patch.object(SimpleEnvironment, 'needs_sudo', return_value=True):
-            with patch.object(EnvJujuClient, 'juju') as mock:
-                client.destroy_environment(env)
-            mock.assert_called_with(
-                'destroy-environment', ('foo', '--force', '-y'),
-                True, check=False, include_e=False, timeout=600.0)
-
-    def test_get_juju_output(self):
-        env = SimpleEnvironment('foo')
-        asdf = lambda x, stderr, env: 'asdf'
-        client = JujuClientDevel(None, None)
-        with patch('subprocess.check_output', side_effect=asdf) as mock:
-            result = client.get_juju_output(env, 'bar')
-        self.assertEqual('asdf', result)
-        self.assertEqual((('juju', '--show-log', 'bar', '-e', 'foo'),),
-                         mock.call_args[0])
-
-    def test_get_juju_output_accepts_varargs(self):
-        env = SimpleEnvironment('foo')
-        asdf = lambda x, stderr, env: 'asdf'
-        client = JujuClientDevel(None, None)
-        with patch('subprocess.check_output', side_effect=asdf) as mock:
-            result = client.get_juju_output(env, 'bar', 'baz', '--qux')
-        self.assertEqual('asdf', result)
-        self.assertEqual((('juju', '--show-log', 'bar', '-e', 'foo', 'baz',
-                           '--qux'),), mock.call_args[0])
-
-    def test_get_juju_output_stderr(self):
-        def raise_without_stderr(args, stderr, env):
-            stderr.write('Hello!')
-            raise subprocess.CalledProcessError('a', 'b')
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, None)
-        with self.assertRaises(subprocess.CalledProcessError) as exc:
-            with patch('subprocess.check_output', raise_without_stderr):
-                client.get_juju_output(env, 'bar')
-        self.assertEqual(exc.exception.stderr, 'Hello!')
-
-    def test_get_juju_output_accepts_timeout(self):
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, None)
-        with patch('subprocess.check_output') as sco_mock:
-            client.get_juju_output(env, 'bar', timeout=5)
-        self.assertEqual(
-            sco_mock.call_args[0][0],
-            (sys.executable, get_timeout_path(), '5.00', '--', 'juju',
-             '--show-log', 'bar', '-e', 'foo'))
-
-    def test_juju_output_supplies_path(self):
-        env = SimpleEnvironment('foo')
-        client = JujuClientDevel(None, '/foobar/bar')
-        with patch('subprocess.check_output') as sco_mock:
-            client.get_juju_output(env, 'baz')
-        self.assertRegexpMatches(sco_mock.call_args[1]['env']['PATH'],
-                                 r'/foobar\:')
-
-    def test_get_status(self):
-        output_text = yield dedent("""\
-                - a
-                - b
-                - c
-                """)
-        client = JujuClientDevel(None, None)
-        env = SimpleEnvironment('foo')
-        with patch.object(EnvJujuClient, 'get_juju_output',
-                          return_value=output_text):
-            result = client.get_status(env)
-        self.assertEqual(Status, type(result))
-        self.assertEqual(['a', 'b', 'c'], result.status)
-
-    def test_get_status_retries_on_error(self):
-        client = JujuClientDevel(None, None)
-        client.attempt = 0
-
-        def get_juju_output(command, *args):
-            if client.attempt == 1:
-                return '"hello"'
-            client.attempt += 1
-            raise subprocess.CalledProcessError(1, command)
-
-        env = SimpleEnvironment('foo')
-        with patch.object(EnvJujuClient, 'get_juju_output', get_juju_output):
-            client.get_status(env)
-
-    def test_get_status_raises_on_timeout_1(self):
-        client = JujuClientDevel(None, None)
-
-        def get_juju_output(command):
-            raise subprocess.CalledProcessError(1, command)
-
-        env = SimpleEnvironment('foo')
-        with patch.object(EnvJujuClient, 'get_juju_output',
-                          side_effect=get_juju_output):
-            with patch('jujupy.until_timeout', lambda x: iter([None, None])):
-                with self.assertRaisesRegexp(
-                        Exception, 'Timed out waiting for juju status'):
-                    client.get_status(env)
-
-    def test_get_status_raises_on_timeout_2(self):
-        client = JujuClientDevel(None, None)
-        env = SimpleEnvironment('foo')
-        with patch('jujupy.until_timeout', return_value=iter([1])) as mock_ut:
-            with patch.object(EnvJujuClient, 'get_juju_output',
-                              side_effect=StopIteration):
-                with self.assertRaises(StopIteration):
-                    client.get_status(env, 500)
-        mock_ut.assert_called_with(500)
-
-    def test_get_env_option(self):
-        client = JujuClientDevel(None, None)
-        env = SimpleEnvironment('foo')
-        with patch('subprocess.check_output') as mock:
-            mock.return_value = 'https://example.org/juju/tools'
-            result = client.get_env_option(env, 'tools-metadata-url')
-        self.assertEqual(
-            mock.call_args[0][0],
-            ('juju', '--show-log', 'get-env', '-e', 'foo',
-             'tools-metadata-url'))
-        self.assertEqual('https://example.org/juju/tools', result)
-
-    def test_set_env_option(self):
-        client = JujuClientDevel(None, None)
-        env = SimpleEnvironment('foo')
-        with patch('subprocess.check_call') as mock:
-            client.set_env_option(
-                env, 'tools-metadata-url', 'https://example.org/juju/tools')
-        environ = dict(os.environ)
-        environ['JUJU_HOME'] = get_juju_home()
-        mock.assert_called_with(
-            ('juju', '--show-log', 'set-env', '-e', 'foo',
-             'tools-metadata-url=https://example.org/juju/tools'),
-            env=environ)
-
-    def test_juju(self):
-        env = SimpleEnvironment('qux')
-        client = JujuClientDevel(None, None)
-        with patch('sys.stdout') as stdout_mock:
-            with patch('subprocess.check_call') as mock:
-                client.juju(env, 'foo', ('bar', 'baz'))
-        environ = dict(os.environ)
-        environ['JUJU_HOME'] = get_juju_home()
-        mock.assert_called_with(('juju', '--show-log', 'foo', '-e', 'qux',
-                                 'bar', 'baz'), env=environ)
-        stdout_mock.flush.assert_called_with()
-
-    def test_juju_env(self):
-        env = SimpleEnvironment('qux')
-        client = JujuClientDevel(None, '/foobar/baz')
-        with patch('subprocess.check_call') as cc_mock:
-            client.juju(env, 'foo', ('bar', 'baz'))
-        self.assertRegexpMatches(cc_mock.call_args[1]['env']['PATH'],
-                                 r'/foobar\:')
-
-    def test_juju_no_check(self):
-        env = SimpleEnvironment('qux')
-        client = JujuClientDevel(None, None)
-        with patch('sys.stdout') as stdout_mock:
-            with patch('subprocess.call') as mock:
-                client.juju(env, 'foo', ('bar', 'baz'), check=False)
-        environ = dict(os.environ)
-        environ['JUJU_HOME'] = get_juju_home()
-        mock.assert_called_with(('juju', '--show-log', 'foo', '-e', 'qux',
-                                 'bar', 'baz'), env=environ)
-        stdout_mock.flush.assert_called_with()
-
-    def test_juju_no_check_env(self):
-        env = SimpleEnvironment('qux')
-        client = JujuClientDevel(None, '/foobar/baz')
-        with patch('subprocess.call') as call_mock:
-            client.juju(env, 'foo', ('bar', 'baz'), check=False)
-        self.assertRegexpMatches(call_mock.call_args[1]['env']['PATH'],
-                                 r'/foobar\:')
-
-
 class TestStatus(TestCase):
 
     def test_iter_machines_no_containers(self):

